/*
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.18
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.UpbitOpenApi) {
      root.UpbitOpenApi = {};
    }
    root.UpbitOpenApi.MarketInfo = factory(root.UpbitOpenApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The MarketInfo model module.
   * @module model/MarketInfo
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>MarketInfo</code>.
   * @alias module:model/MarketInfo
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>MarketInfo</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/MarketInfo} obj Optional instance to populate.
   * @return {module:model/MarketInfo} The populated <code>MarketInfo</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('market'))
        obj.market = ApiClient.convertToType(data['market'], 'String');
      if (data.hasOwnProperty('korean_name'))
        obj.koreanName = ApiClient.convertToType(data['korean_name'], 'String');
      if (data.hasOwnProperty('english_name'))
        obj.englishName = ApiClient.convertToType(data['english_name'], 'String');
      if (data.hasOwnProperty('market_warning'))
        obj.marketWarning = ApiClient.convertToType(data['market_warning'], 'String');
    }
    return obj;
  }

  /**
   * 업비트에서 제공중인 시장 정보
   * @member {String} market
   */
  exports.prototype.market = undefined;

  /**
   * 거래 대상 암호화폐 한글명
   * @member {String} koreanName
   */
  exports.prototype.koreanName = undefined;

  /**
   * 거래 대상 암호화폐 영문명
   * @member {String} englishName
   */
  exports.prototype.englishName = undefined;

  /**
   * 유의 종목 여부 - NONE (해당 사항 없음) - CAUTION (투자유의) 
   * @member {String} marketWarning
   */
  exports.prototype.marketWarning = undefined;


  return exports;

}));
