# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' Account Class
#'
#' @field currency 
#' @field balance 
#' @field locked 
#' @field avg_buy_price 
#' @field avg_buy_price_modified 
#' @field unit_currency 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
Account <- R6::R6Class(
  'Account',
  public = list(
    `currency` = NULL,
    `balance` = NULL,
    `locked` = NULL,
    `avg_buy_price` = NULL,
    `avg_buy_price_modified` = NULL,
    `unit_currency` = NULL,
    initialize = function(`currency`, `balance`, `locked`, `avg_buy_price`, `avg_buy_price_modified`, `unit_currency`){
      if (!missing(`currency`)) {
        stopifnot(is.character(`currency`), length(`currency`) == 1)
        self$`currency` <- `currency`
      }
      if (!missing(`balance`)) {
        stopifnot(is.character(`balance`), length(`balance`) == 1)
        self$`balance` <- `balance`
      }
      if (!missing(`locked`)) {
        stopifnot(is.character(`locked`), length(`locked`) == 1)
        self$`locked` <- `locked`
      }
      if (!missing(`avg_buy_price`)) {
        stopifnot(is.character(`avg_buy_price`), length(`avg_buy_price`) == 1)
        self$`avg_buy_price` <- `avg_buy_price`
      }
      if (!missing(`avg_buy_price_modified`)) {
        self$`avg_buy_price_modified` <- `avg_buy_price_modified`
      }
      if (!missing(`unit_currency`)) {
        stopifnot(is.character(`unit_currency`), length(`unit_currency`) == 1)
        self$`unit_currency` <- `unit_currency`
      }
    },
    toJSON = function() {
      AccountObject <- list()
      if (!is.null(self$`currency`)) {
        AccountObject[['currency']] <- self$`currency`
      }
      if (!is.null(self$`balance`)) {
        AccountObject[['balance']] <- self$`balance`
      }
      if (!is.null(self$`locked`)) {
        AccountObject[['locked']] <- self$`locked`
      }
      if (!is.null(self$`avg_buy_price`)) {
        AccountObject[['avg_buy_price']] <- self$`avg_buy_price`
      }
      if (!is.null(self$`avg_buy_price_modified`)) {
        AccountObject[['avg_buy_price_modified']] <- self$`avg_buy_price_modified`
      }
      if (!is.null(self$`unit_currency`)) {
        AccountObject[['unit_currency']] <- self$`unit_currency`
      }

      AccountObject
    },
    fromJSON = function(AccountJson) {
      AccountObject <- jsonlite::fromJSON(AccountJson)
      if (!is.null(AccountObject$`currency`)) {
        self$`currency` <- AccountObject$`currency`
      }
      if (!is.null(AccountObject$`balance`)) {
        self$`balance` <- AccountObject$`balance`
      }
      if (!is.null(AccountObject$`locked`)) {
        self$`locked` <- AccountObject$`locked`
      }
      if (!is.null(AccountObject$`avg_buy_price`)) {
        self$`avg_buy_price` <- AccountObject$`avg_buy_price`
      }
      if (!is.null(AccountObject$`avg_buy_price_modified`)) {
        self$`avg_buy_price_modified` <- AccountObject$`avg_buy_price_modified`
      }
      if (!is.null(AccountObject$`unit_currency`)) {
        self$`unit_currency` <- AccountObject$`unit_currency`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "currency": %s,
           "balance": %s,
           "locked": %s,
           "avg_buy_price": %s,
           "avg_buy_price_modified": %s,
           "unit_currency": %s
        }',
        self$`currency`,
        self$`balance`,
        self$`locked`,
        self$`avg_buy_price`,
        self$`avg_buy_price_modified`,
        self$`unit_currency`
      )
    },
    fromJSONString = function(AccountJson) {
      AccountObject <- jsonlite::fromJSON(AccountJson)
      self$`currency` <- AccountObject$`currency`
      self$`balance` <- AccountObject$`balance`
      self$`locked` <- AccountObject$`locked`
      self$`avg_buy_price` <- AccountObject$`avg_buy_price`
      self$`avg_buy_price_modified` <- AccountObject$`avg_buy_price_modified`
      self$`unit_currency` <- AccountObject$`unit_currency`
    }
  )
)
